#!/bin/bash
#------------------------------------------------------------------------------
# Copyright (c) 2007-2020 Olaf Jaehrling <eisfair(at)ojaehrling.(dot)de>
#
# Creation:     2007-12-22 by Olaf Jaehrling
# Last Update:  2020-08-31 by Olaf Jaehrling
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License
#------------------------------------------------------------------------------

package='net-snmp'
package_name='net-snmp'

UPDATE=0

. /var/install/include/eislib

if [ -f /tmp/net-snmp_configfile ]
then
    mv /tmp/net-snmp_configfile etc/config.d/$package
fi

if [ -f "/etc/config.d/$package" ]
then
    ### update configuration
    mecho -info "loading previous configuration file ..."
    UPDATE=1
fi
if ! grep -wq setup.services.net-snmp.menu /var/install/menu/setup.services.menu
then
    mecho --info "insert net-snmp service menu ..."
    ### add menu
    /var/install/bin/add-menu              \
     setup.services.menu                \
     setup.services.$package.menu       \
     $package_name

fi
sh /var/install/config.d/$package-update.sh 
if [ "$UPDATE" = "0" ]
then
    echo "please run setup to configure and activate $package"
    sleep 5
else
    /var/install/config.d/$package.sh > /dev/null
    service restart $package >/dev/null
fi
# /var/install/bin/edit -apply $package "Edit $package_name configuration"

rm -f /etc/init.d/net-snmp
exit 0

