#!/bin/bash
#------------------------------------------------------------------------------
# Copyright (c) 2007-2020 Olaf Jaehrling <eisfair(at)ojaehrling.(dot)de>
#
# Creation:     2007-12-22 by Olaf Jaehrling
# Last Update:  2020-08-31 by Olaf Jaehrling
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License
#------------------------------------------------------------------------------

package='net-snmp'
package_name='net-snmp'
needed_base='2.8.25'

### check base version
if [ ! -f /var/install/bin/check-version ] ||
   [ `/var/install/bin/check-version base $needed_base` = "new" ]
then
    echo
    echo
    colecho "The version of eisfair must be $needed_base or higher." rd w brinv
    colecho "Please update your eisfair system first." rd w brinv
    echo
    echo
    exit 1
fi


. /var/install/include/eislib
mecho -info "checking of old snmpwalk package"
if [ -f /var/install/packages/snmpwalk ]
then
    mecho -error "old snmpwalk package detected"
    mecho -error "Please delete follow packages first."
    mecho -error "snmp_lib"
    mecho -error "snmp_module"
    mecho -error "snmpwalk"
    exit 255
else
    mecho -info "old snmpwalk package not found"
fi

mecho -info "checking of old net_snmp package"
if [ -f /var/install/packages/net_snmp ]
then
    /var/install/bin/del-package net_snmp update
else
    mecho -info "old net_snmp package not found"
fi
## checking for installing haederfiles from net-snmp packages older then 0.0.3

version=$(/var/install/bin/check-version net-snmp 0.0.3)

if [ "$version" = "new" -a -d /usr/include/net-snmp ]
then
    rm -rf /usr/include/net-snmp
fi

version=`/var/install/bin/check-version net-snmp 2.0.7`
if [ "$version" = "new" ]
then
    if [ -f /etc/config.d/net-snmp ]
    then
        cp /etc/config.d/net-snmp /tmp/net-snmp_configfile
        cp /etc/snmpd.conf /tmp/etc_snmpd.conf
    fi
fi

exit 0
