#!/bin/bash
#----------------------------------------------------------------------------
# Creation:     05.07.2005  OJae
# Last Update:  13.12.2019  OJae
#
# Copyright (c) 2005-2019 Olaf Jaehrling <eisfair@ojaehrling.de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#------------------------------------------------------------------------------
. /etc/config.d/net-snmp
. /var/install/include/eislib

>/tmp/snmpoptions
(
echo "# Please see /usr/share/doc/net-snmp/EXAMPLE.conf for a"
echo "# "
echo "# Writing is disabled by default for security reasons.  If you'd like"
echo "# to enable it uncomment the rwcommunity line and change the community"
echo "# name to something nominally secure (keeping in mind that this is"
echo "# transmitted in clear text)."
echo " "
echo "# don't use ' < > in strings for syslocation or syscontact"
echo "# Note that if you define the following here you won't be able to change"
echo "# them with snmpset"
echo "syslocation $NET_SNMP_LOCATION_NAME"
echo "syscontact $NET_SNMP_ADMIN_NAME ($SNMPWALK_ADMIN_MAIL)"
echo " "
) >/etc/snmpd.conf

idx=1

if [ "$NET_SNMP_USE_V3" = "yes" ]
then
    echo "agentAddress udp:161,udp6:161" >>/etc/snmpd.conf
else
    echo "agentAddress udp:161" >>/etc/snmpd.conf
fi

idx=1
while [ "$idx" -le "$NET_SNMP_RO_ALLOWED_N" ]
do
    eval name='$NET_SNMP_RO_'$idx'_COMMUNITY_NAME'
    eval ip='$NET_SNMP_RO_'$idx'_ALLOWED_IP'
    echo "rocommunity $name $ip" >>/etc/snmpd.conf
idx=`/usr/bin/expr $idx + 1`
done

idx=1
while [ "$idx" -le "$NET_SNMP_RW_ALLOWED_N" ]
do
    eval name='$NET_SNMP_RW_'$idx'_COMMUNITY_NAME'
    eval ip='$NET_SNMP_RW_'$idx'_ALLOWED_IP'
    echo "rwcommunity $name $ip" >>/etc/snmpd.conf
idx=`/usr/bin/expr $idx + 1`
done


if [ "$NET_SNMP_USE_V3" = "yes" ]
then
    idx=1
    while [ "$idx" -le "$NET_SNMP_V3_RO_N" ]
    do
        eval v3rouser='$NET_SNMP_V3_RO_'$idx'_USERNAME'
        eval v3ropass='$NET_SNMP_V3_RO_'$idx'_PASSWORD'
        eval v3roauth='$NET_SNMP_V3_RO_'$idx'_AUTH'
        eval v3roauthproto='$NET_SNMP_V3_RO_'$idx'_AUTH_PROTOCOL'
        eval v3ropriv='$NET_SNMP_V3_RO_'$idx'_PRIV'
        eval v3roprivproto='$NET_SNMP_V3_RO_'$idx'_PRIV_PROTOCOL'
        eval v3roprivpass='$NET_SNMP_V3_RO_'$idx'_PRIV_PASS'
#        eval v3roip='$NET_SNMP_V3_RO_'$idx'_ALLOWED_IP'
        if [ "$v3rouser" != "" ]
        then
            echo "createUser $v3rouser $v3roauthproto $v3ropass $v3roprivproto $v3roprivpass" >> /etc/snmpd.conf
            echo "rouser $v3rouser" >> /etc/snmpd.conf
        fi
    idx=`/usr/bin/expr $idx + 1`
    done

    idx=1
    while [ "$idx" -le "$NET_SNMP_V3_RW_N" ]
    do
        eval v3rwuser='$NET_SNMP_V3_RW_'$idx'_USERNAME'
        eval v3rwpass='$NET_SNMP_V3_RW_'$idx'_PASSWORD'
        eval v3rwauth='$NET_SNMP_V3_RW_'$idx'_AUTH'
        eval v3rwauthproto='$NET_SNMP_V3_RW_'$idx'_AUTH_PROTOCOL'
        eval v3rwpriv='$NET_SNMP_V3_RW_'$idx'_PRIV'
        eval v3rwprivproto='$NET_SNMP_V3_RW_'$idx'_PRIV_PROTOCOL'
        eval v3rwprivpass='$NET_SNMP_V3_RW_'$idx'_PRIV_PASS'
#        eval v3rwip='$NET_SNMP_V3_RW_'$idx'_ALLOWED_IP'
        if [ "$v3rwuser" != "" ]
        then
            echo "createUser $v3rwuser $v3rwauthproto $v3rwpass $v3rwprivproto $v3rwprivpass" >> /etc/snmpd.conf
            echo "rwuser $v3rwuser" >> /etc/snmpd.conf
        fi
    idx=`/usr/bin/expr $idx + 1`
    done
fi

if [ "$NET_SNMP_LOG" = "yes" ]
then
    if [ "$NET_SNMP_OWN_LOGFILE" = "no" ]
    then
        echo "-Lsd -Lf /dev/null" >/tmp/snmpoptions
    else
        echo "-Lf "$NET_SNMP_LOGFILE >/tmp/snmpoptions
    fi
fi

echo $NET_SNMP_OPTIONS >>/tmp/snmpoptions
idx1=`/usr/bin/expr $idx1 + 1`
echo "-c /etc/snmpd.conf -p /run/snmpd -a" >>/tmp/snmpoptions
/bin/cat /tmp/snmpoptions | tr '\n' ' ' >/etc/snmpoptions
        
if [ "$START_NET_SNMP" = "yes" ]
then
    systemctl enable net-snmp
else
    systemctl disable net-snmp
fi
